"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UnControlled = exports.Controlled = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var React = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * Copy of [react-codemirror2](https://github.com/scniro/react-codemirror2/blob/0f2bb13cad2fb1364eb063cbd7ec9aae726a55eb/src/index.tsx)
 * - no adjustments, just for `React 17` support
 * Copyright (c) 2020   Sal Niro
 * @license see [github.com/scniro/react-codemirror2](https://github.com/scniro/react-codemirror2/blob/0f2bb13cad2fb1364eb063cbd7ec9aae726a55eb/LICENSE)
 */
var SERVER_RENDERED = typeof navigator === 'undefined' || typeof global !== 'undefined' && global['PREVENT_CODEMIRROR_RENDER'] === true;
var cm;

if (!SERVER_RENDERED) {
  cm = require('codemirror');
}

var Helper = /*#__PURE__*/function () {
  function Helper() {
    (0, _classCallCheck2["default"])(this, Helper);
  }

  (0, _createClass2["default"])(Helper, null, [{
    key: "equals",
    value: function equals(x, y) {
      var _this = this;

      var ok = Object.keys,
          tx = (0, _typeof2["default"])(x),
          ty = (0, _typeof2["default"])(y);
      return x && y && tx === 'object' && tx === ty ? ok(x).length === ok(y).length && ok(x).every(function (key) {
        return _this.equals(x[key], y[key]);
      }) : x === y;
    }
  }]);
  return Helper;
}();

var Shared = /*#__PURE__*/function () {
  function Shared(editor, props) {
    (0, _classCallCheck2["default"])(this, Shared);
    (0, _defineProperty2["default"])(this, "editor", void 0);
    (0, _defineProperty2["default"])(this, "props", void 0);
    this.editor = editor;
    this.props = props;
  }

  (0, _createClass2["default"])(Shared, [{
    key: "delegateCursor",
    value: function delegateCursor(position, scroll, focus) {
      var doc = this.editor.getDoc();

      if (focus) {
        this.editor.focus();
      }

      scroll ? doc.setCursor(position) : doc.setCursor(position, null, {
        scroll: false
      });
    }
  }, {
    key: "delegateScroll",
    value: function delegateScroll(coordinates) {
      this.editor.scrollTo(coordinates.x, coordinates.y);
    }
  }, {
    key: "delegateSelection",
    value: function delegateSelection(ranges, focus) {
      var doc = this.editor.getDoc();
      doc.setSelections(ranges);

      if (focus) {
        this.editor.focus();
      }
    }
  }, {
    key: "apply",
    value: function apply(props) {
      // init ranges
      if (props && props.selection && props.selection.ranges) {
        this.delegateSelection(props.selection.ranges, props.selection.focus || false);
      } // init cursor


      if (props && props.cursor) {
        this.delegateCursor(props.cursor, props.autoScroll || false, this.editor.getOption('autofocus') || false);
      } // init scroll


      if (props && props.scroll) {
        this.delegateScroll(props.scroll);
      }
    }
  }, {
    key: "applyNext",
    value: function applyNext(props, next, preserved) {
      // handle new ranges
      if (props && props.selection && props.selection.ranges) {
        if (next && next.selection && next.selection.ranges && !Helper.equals(props.selection.ranges, next.selection.ranges)) {
          this.delegateSelection(next.selection.ranges, next.selection.focus || false);
        }
      } // handle new cursor


      if (props && props.cursor) {
        if (next && next.cursor && !Helper.equals(props.cursor, next.cursor)) {
          this.delegateCursor(preserved.cursor || next.cursor, next.autoScroll || false, next.autoCursor || false);
        }
      } // handle new scroll


      if (props && props.scroll) {
        if (next && next.scroll && !Helper.equals(props.scroll, next.scroll)) {
          this.delegateScroll(next.scroll);
        }
      }
    }
  }, {
    key: "applyUserDefined",
    value: function applyUserDefined(props, preserved) {
      if (preserved && preserved.cursor) {
        this.delegateCursor(preserved.cursor, props.autoScroll || false, this.editor.getOption('autofocus') || false);
      }
    }
  }, {
    key: "wire",
    value: function wire(props) {
      var _this2 = this;

      Object.keys(props || {}).filter(function (p) {
        return /^on/.test(p);
      }).forEach(function (prop) {
        switch (prop) {
          case 'onBlur':
            {
              _this2.editor.on('blur', function (cm, event) {
                _this2.props.onBlur(_this2.editor, event);
              });
            }
            break;

          case 'onContextMenu':
            {
              _this2.editor.on('contextmenu', function (cm, event) {
                _this2.props.onContextMenu(_this2.editor, event);
              });

              break;
            }

          case 'onCopy':
            {
              _this2.editor.on('copy', function (cm, event) {
                _this2.props.onCopy(_this2.editor, event);
              });

              break;
            }

          case 'onCursor':
            {
              _this2.editor.on('cursorActivity', function (cm) {
                _this2.props.onCursor(_this2.editor, _this2.editor.getDoc().getCursor());
              });
            }
            break;

          case 'onCursorActivity':
            {
              _this2.editor.on('cursorActivity', function (cm) {
                _this2.props.onCursorActivity(_this2.editor);
              });
            }
            break;

          case 'onCut':
            {
              _this2.editor.on('cut', function (cm, event) {
                _this2.props.onCut(_this2.editor, event);
              });

              break;
            }

          case 'onDblClick':
            {
              _this2.editor.on('dblclick', function (cm, event) {
                _this2.props.onDblClick(_this2.editor, event);
              });

              break;
            }

          case 'onDragEnter':
            {
              _this2.editor.on('dragenter', function (cm, event) {
                _this2.props.onDragEnter(_this2.editor, event);
              });
            }
            break;

          case 'onDragLeave':
            {
              _this2.editor.on('dragleave', function (cm, event) {
                _this2.props.onDragLeave(_this2.editor, event);
              });

              break;
            }

          case 'onDragOver':
            {
              _this2.editor.on('dragover', function (cm, event) {
                _this2.props.onDragOver(_this2.editor, event);
              });
            }
            break;

          case 'onDragStart':
            {
              _this2.editor.on('dragstart', function (cm, event) {
                _this2.props.onDragStart(_this2.editor, event);
              });

              break;
            }

          case 'onDrop':
            {
              _this2.editor.on('drop', function (cm, event) {
                _this2.props.onDrop(_this2.editor, event);
              });
            }
            break;

          case 'onFocus':
            {
              _this2.editor.on('focus', function (cm, event) {
                _this2.props.onFocus(_this2.editor, event);
              });
            }
            break;

          case 'onGutterClick':
            {
              _this2.editor.on('gutterClick', function (cm, lineNumber, gutter, event) {
                _this2.props.onGutterClick(_this2.editor, lineNumber, gutter, event);
              });
            }
            break;

          case 'onInputRead':
            {
              _this2.editor.on('inputRead', function (cm, EditorChangeEvent) {
                _this2.props.onInputRead(_this2.editor, EditorChangeEvent);
              });
            }
            break;

          case 'onKeyDown':
            {
              _this2.editor.on('keydown', function (cm, event) {
                _this2.props.onKeyDown(_this2.editor, event);
              });
            }
            break;

          case 'onKeyHandled':
            {
              _this2.editor.on('keyHandled', function (cm, key, event) {
                _this2.props.onKeyHandled(_this2.editor, key, event);
              });
            }
            break;

          case 'onKeyPress':
            {
              _this2.editor.on('keypress', function (cm, event) {
                _this2.props.onKeyPress(_this2.editor, event);
              });
            }
            break;

          case 'onKeyUp':
            {
              _this2.editor.on('keyup', function (cm, event) {
                _this2.props.onKeyUp(_this2.editor, event);
              });
            }
            break;

          case 'onMouseDown':
            {
              _this2.editor.on('mousedown', function (cm, event) {
                _this2.props.onMouseDown(_this2.editor, event);
              });

              break;
            }

          case 'onPaste':
            {
              _this2.editor.on('paste', function (cm, event) {
                _this2.props.onPaste(_this2.editor, event);
              });

              break;
            }

          case 'onRenderLine':
            {
              _this2.editor.on('renderLine', function (cm, line, element) {
                _this2.props.onRenderLine(_this2.editor, line, element);
              });

              break;
            }

          case 'onScroll':
            {
              _this2.editor.on('scroll', function (cm) {
                _this2.props.onScroll(_this2.editor, _this2.editor.getScrollInfo());
              });
            }
            break;

          case 'onSelection':
            {
              _this2.editor.on('beforeSelectionChange', function (cm, data) {
                _this2.props.onSelection(_this2.editor, data);
              });
            }
            break;

          case 'onTouchStart':
            {
              _this2.editor.on('touchstart', function (cm, event) {
                _this2.props.onTouchStart(_this2.editor, event);
              });

              break;
            }

          case 'onUpdate':
            {
              _this2.editor.on('update', function (cm) {
                _this2.props.onUpdate(_this2.editor);
              });
            }
            break;

          case 'onViewportChange':
            {
              _this2.editor.on('viewportChange', function (cm, from, to) {
                _this2.props.onViewportChange(_this2.editor, from, to);
              });
            }
            break;
        }
      });
    }
  }]);
  return Shared;
}();

var Controlled = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Controlled, _React$Component);

  var _super = _createSuper(Controlled);

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */
  function Controlled(props) {
    var _this3;

    (0, _classCallCheck2["default"])(this, Controlled);
    _this3 = _super.call(this, props);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "applied", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "appliedNext", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "appliedUserDefined", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "deferred", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "editor", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "emulating", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "hydrated", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "initCb", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "mirror", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "mounted", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "ref", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this3), "shared", void 0);
    if (SERVER_RENDERED) return (0, _possibleConstructorReturn2["default"])(_this3);
    _this3.applied = false;
    _this3.appliedNext = false;
    _this3.appliedUserDefined = false;
    _this3.deferred = null;
    _this3.emulating = false;
    _this3.hydrated = false;

    _this3.initCb = function () {
      if (_this3.props.editorDidConfigure) {
        _this3.props.editorDidConfigure(_this3.editor);
      }
    };

    _this3.mounted = false;
    return _this3;
  }
  /** @internal */


  (0, _createClass2["default"])(Controlled, [{
    key: "hydrate",
    value: function hydrate(props) {
      var _this4 = this;

      var _options = props && props.options ? props.options : {};

      var userDefinedOptions = Object.assign({}, cm.defaults, this.editor.options, _options);
      var optionDelta = Object.keys(userDefinedOptions).some(function (key) {
        return _this4.editor.getOption(key) !== userDefinedOptions[key];
      });

      if (optionDelta) {
        Object.keys(userDefinedOptions).forEach(function (key) {
          if (_options.hasOwnProperty(key)) {
            if (_this4.editor.getOption(key) !== userDefinedOptions[key]) {
              _this4.editor.setOption(key, userDefinedOptions[key]);

              _this4.mirror.setOption(key, userDefinedOptions[key]);
            }
          }
        });
      }

      if (!this.hydrated) {
        this.deferred ? this.resolveChange(props.value) : this.initChange(props.value || '');
      }

      this.hydrated = true;
    }
    /** @internal */

  }, {
    key: "initChange",
    value: function initChange(value) {
      this.emulating = true;
      var doc = this.editor.getDoc();
      var lastLine = doc.lastLine();
      var lastChar = doc.getLine(doc.lastLine()).length;
      doc.replaceRange(value || '', {
        line: 0,
        ch: 0
      }, {
        line: lastLine,
        ch: lastChar
      });
      this.mirror.setValue(value);
      doc.clearHistory();
      this.mirror.clearHistory();
      this.emulating = false;
    }
    /** @internal */

  }, {
    key: "resolveChange",
    value: function resolveChange(value) {
      this.emulating = true;
      var doc = this.editor.getDoc();

      if (this.deferred.origin === 'undo') {
        doc.undo();
      } else if (this.deferred.origin === 'redo') {
        doc.redo();
      } else {
        doc.replaceRange(this.deferred.text, this.deferred.from, this.deferred.to, this.deferred.origin);
      }

      if (value && value !== doc.getValue()) {
        var cursor = doc.getCursor();
        doc.setValue(value);
        doc.setCursor(cursor);
      }

      this.emulating = false;
      this.deferred = null;
    }
    /** @internal */

  }, {
    key: "mirrorChange",
    value: function mirrorChange(deferred) {
      var doc = this.editor.getDoc();

      if (deferred.origin === 'undo') {
        doc.setHistory(this.mirror.getHistory());
        this.mirror.undo();
      } else if (deferred.origin === 'redo') {
        doc.setHistory(this.mirror.getHistory());
        this.mirror.redo();
      } else {
        this.mirror.replaceRange(deferred.text, deferred.from, deferred.to, deferred.origin);
      }

      return this.mirror.getValue();
    }
    /** @internal */

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this5 = this;

      if (SERVER_RENDERED) return;

      if (this.props.defineMode) {
        if (this.props.defineMode.name && this.props.defineMode.fn) {
          cm.defineMode(this.props.defineMode.name, this.props.defineMode.fn);
        }
      }

      this.editor = cm(this.ref, this.props.options);
      this.shared = new Shared(this.editor, this.props);
      this.mirror = cm(function () {}, this.props.options);
      this.editor.on('electricInput', function () {
        _this5.mirror.setHistory(_this5.editor.getDoc().getHistory());
      });
      this.editor.on('cursorActivity', function () {
        _this5.mirror.setCursor(_this5.editor.getDoc().getCursor());
      });
      this.editor.on('beforeChange', function (cm, data) {
        if (_this5.emulating) {
          return;
        }

        data.cancel();
        _this5.deferred = data;

        var phantomChange = _this5.mirrorChange(_this5.deferred);

        if (_this5.props.onBeforeChange) _this5.props.onBeforeChange(_this5.editor, _this5.deferred, phantomChange);
      });
      this.editor.on('change', function (cm, data) {
        if (!_this5.mounted) {
          return;
        }

        if (_this5.props.onChange) {
          _this5.props.onChange(_this5.editor, data, _this5.editor.getValue());
        }
      });
      this.hydrate(this.props);
      this.shared.apply(this.props);
      this.applied = true;
      this.mounted = true;
      this.shared.wire(this.props);

      if (this.editor.getOption('autofocus')) {
        this.editor.focus();
      }

      if (this.props.editorDidMount) {
        this.props.editorDidMount(this.editor, this.editor.getValue(), this.initCb);
      }
    }
    /** @internal */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (SERVER_RENDERED) return;
      var preserved = {
        cursor: null
      };

      if (this.props.value !== prevProps.value) {
        this.hydrated = false;
      }

      if (!this.props.autoCursor && this.props.autoCursor !== undefined) {
        preserved.cursor = this.editor.getDoc().getCursor();
      }

      this.hydrate(this.props);

      if (!this.appliedNext) {
        this.shared.applyNext(prevProps, this.props, preserved);
        this.appliedNext = true;
      }

      this.shared.applyUserDefined(prevProps, preserved);
      this.appliedUserDefined = true;
    }
    /** @internal */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (SERVER_RENDERED) return;

      if (this.props.editorWillUnmount) {
        this.props.editorWillUnmount(cm);
      }
    }
    /** @internal */

  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !SERVER_RENDERED;
    }
    /** @internal */

  }, {
    key: "render",
    value: function render() {
      var _this6 = this;

      if (SERVER_RENDERED) return null;
      var className = this.props.className ? "react-codemirror2 ".concat(this.props.className) : 'react-codemirror2';
      return /*#__PURE__*/React.createElement("div", {
        className: className,
        ref: function ref(self) {
          return _this6.ref = self;
        }
      });
    }
  }]);
  return Controlled;
}(React.Component);

exports.Controlled = Controlled;

var UnControlled = /*#__PURE__*/function (_React$Component2) {
  (0, _inherits2["default"])(UnControlled, _React$Component2);

  var _super2 = _createSuper(UnControlled);

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */
  function UnControlled(props) {
    var _this7;

    (0, _classCallCheck2["default"])(this, UnControlled);
    _this7 = _super2.call(this, props);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "applied", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "appliedUserDefined", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "continueChange", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "detached", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "editor", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "hydrated", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "initCb", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "mounted", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "onBeforeChangeCb", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "ref", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this7), "shared", void 0);
    if (SERVER_RENDERED) return (0, _possibleConstructorReturn2["default"])(_this7);
    _this7.applied = false;
    _this7.appliedUserDefined = false;
    _this7.continueChange = false;
    _this7.detached = false;
    _this7.hydrated = false;

    _this7.initCb = function () {
      if (_this7.props.editorDidConfigure) {
        _this7.props.editorDidConfigure(_this7.editor);
      }
    };

    _this7.mounted = false;

    _this7.onBeforeChangeCb = function () {
      _this7.continueChange = true;
    };

    return _this7;
  }
  /** @internal */


  (0, _createClass2["default"])(UnControlled, [{
    key: "hydrate",
    value: function hydrate(props) {
      var _this8 = this;

      var _options = props && props.options ? props.options : {};

      var userDefinedOptions = Object.assign({}, cm.defaults, this.editor.options, _options);
      var optionDelta = Object.keys(userDefinedOptions).some(function (key) {
        return _this8.editor.getOption(key) !== userDefinedOptions[key];
      });

      if (optionDelta) {
        Object.keys(userDefinedOptions).forEach(function (key) {
          if (_options.hasOwnProperty(key)) {
            if (_this8.editor.getOption(key) !== userDefinedOptions[key]) {
              _this8.editor.setOption(key, userDefinedOptions[key]);
            }
          }
        });
      }

      if (!this.hydrated) {
        var doc = this.editor.getDoc();
        var lastLine = doc.lastLine();
        var lastChar = doc.getLine(doc.lastLine()).length;
        doc.replaceRange(props.value || '', {
          line: 0,
          ch: 0
        }, {
          line: lastLine,
          ch: lastChar
        });
      }

      this.hydrated = true;
    }
    /** @internal */

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this9 = this;

      if (SERVER_RENDERED) return;
      this.detached = this.props.detach === true;

      if (this.props.defineMode) {
        if (this.props.defineMode.name && this.props.defineMode.fn) {
          cm.defineMode(this.props.defineMode.name, this.props.defineMode.fn);
        }
      }

      this.editor = cm(this.ref, this.props.options);
      this.shared = new Shared(this.editor, this.props);
      this.editor.on('beforeChange', function (cm, data) {
        if (_this9.props.onBeforeChange) {
          _this9.props.onBeforeChange(_this9.editor, data, _this9.editor.getValue(), _this9.onBeforeChangeCb);
        }
      });
      this.editor.on('change', function (cm, data) {
        if (!_this9.mounted || !_this9.props.onChange) {
          return;
        }

        if (_this9.props.onBeforeChange) {
          if (_this9.continueChange) {
            _this9.props.onChange(_this9.editor, data, _this9.editor.getValue());
          }
        } else {
          _this9.props.onChange(_this9.editor, data, _this9.editor.getValue());
        }
      });
      this.hydrate(this.props);
      this.shared.apply(this.props);
      this.applied = true;
      this.mounted = true;
      this.shared.wire(this.props);
      this.editor.getDoc().clearHistory();

      if (this.props.editorDidMount) {
        this.props.editorDidMount(this.editor, this.editor.getValue(), this.initCb);
      }
    }
    /** @internal */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.detached && this.props.detach === false) {
        this.detached = false;

        if (prevProps.editorDidAttach) {
          prevProps.editorDidAttach(this.editor);
        }
      }

      if (!this.detached && this.props.detach === true) {
        this.detached = true;

        if (prevProps.editorDidDetach) {
          prevProps.editorDidDetach(this.editor);
        }
      }

      if (SERVER_RENDERED || this.detached) return;
      var preserved = {
        cursor: null
      };

      if (this.props.value !== prevProps.value) {
        this.hydrated = false;
        this.applied = false;
        this.appliedUserDefined = false;
      }

      if (!prevProps.autoCursor && prevProps.autoCursor !== undefined) {
        preserved.cursor = this.editor.getDoc().getCursor();
      }

      this.hydrate(this.props);

      if (!this.applied) {
        this.shared.apply(prevProps);
        this.applied = true;
      }

      if (!this.appliedUserDefined) {
        this.shared.applyUserDefined(prevProps, preserved);
        this.appliedUserDefined = true;
      }
    }
    /** @internal */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (SERVER_RENDERED) return;

      if (this.props.editorWillUnmount) {
        this.props.editorWillUnmount(cm);
      }
    }
    /** @internal */

  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      var update = true;
      if (SERVER_RENDERED) update = false;
      if (this.detached && nextProps.detach) update = false;
      return update;
    }
    /** @internal */

  }, {
    key: "render",
    value: function render() {
      var _this10 = this;

      if (SERVER_RENDERED) return null;
      var className = this.props.className ? "react-codemirror2 ".concat(this.props.className) : 'react-codemirror2';
      return /*#__PURE__*/React.createElement("div", {
        className: className,
        ref: function ref(self) {
          return _this10.ref = self;
        }
      });
    }
  }]);
  return UnControlled;
}(React.Component);

exports.UnControlled = UnControlled;